package exprconst;

import java.util.ArrayList;

public class Operation implements Expr{
	private Operator op;   // opérateur
	private Expr e1, e2;   // opérandes
	
	public Operation(Operator o, Expr a1, Expr a2){
		op=o; e1=a1; e2=a2;
	}
	/**
	 * Retourne la liste des opérandes
	 */
	public ArrayList<Expr> operandes() {
		ArrayList<Expr> res = new ArrayList<Expr>();
		res.add(e1); res.add(e2);
		return res;
	}
	/**
	 * Valeur d'une expression de type "opération".
	 */
	public int val() {
		int v1 = e1.val();
		int v2 = e2.val();
	    switch (op) {
	      case Plus: return v1 + v2;
	      case Sub: return  v1 - v2;
	      case Mul: return  v1 * v2;
	      case Div: return  v1 / v2 ;
	    }
	    throw new Error ("eval : arbre Exp incorrect") ;
	}
	
	public String toString(){
	    switch (op) {
	      case Plus: return "+( " + e1.toString() + ", " + e2.toString() + ")" ;
	      case Sub:  return "-( " + e1.toString() + ", " + e2.toString() + ")" ;
	      case Mul: return "*( " + e1.toString() + ", " + e2.toString() + ")" ;
	      case Div: return "/( " + e1.toString() + ", " + e2.toString() + ")" ;
	    }
	    throw new Error ("eval : arbre Exp incorrect") ;
	}
}
